#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
###2004-0327 - Bandview v.0.1.1 mod by catastrophe (initial release)
# - Intended for use on Smoothwall Express 2.0 p2 ui-3.6.1
# - This mod was inspired by the ipacsum mod developed by Antonio Bugan (Nov 26, 2003) 
# - Color graph routine inspired by advstatus.cgi by The Smoothwall Team
# - Implementation of v2.1 pack system by Tiago Freitas Leal
# - Added 'by anniversary' support via unmodified usage.pl (2004-0107) by Matthew Yager (Unicorn) 
# - Display ipacsum usage for today, yesterday, this week, this month*, this year, all
# - Calculate and generate bandwidth use/over-use with graph for current month 'by anniversary'
# - On the fly IP accounting summary run without '--fixed-quantity M' and '-z'
# - Added no bandwidth cap or limit
###2004-0328 - Bandview v.0.2 mod by catastrophe (bug-fix)
# - Install/Uninstall scripts "friendly" to users with the Monthly ipacsum Usage mod by Unicorn pre-installed
###2004-0329 - Bandview v.0.2.1 mod by catastrophe
# - Updated code credits. Sorry if I left anyone out by mistake.
###2004-0331 - Bandview v.0.3 mod by catastrophe
# - Added selectable page refresh rate (0ff,30s,300s,600s,1800s,3600s)
# - Added "hide zeroes" and "on top" checkboxes for the ip accounting summary
# - Added support for users manually added to writeipac.pl as described in the IP Accounting mod by mpot on 2004-0107
# - Added user cap for users under monthly monitor
###2004-0421 - Bandview v.0.4 mod by catastrophe (bug-fix)
# - Fixed some variable initialization problems
# - Fixed "failed thisperiod.stats creation" by removing LF from usage.dat
# - Fixed the occassional but annoying "scrunched user monitor" 
# - Prepped for bwbar v1.2.2 by H. Peter Anvin (from kernel.org) add-on
###2004-0422 - Bandview v.0.4.1 mod by catastrophe
# - Minor repack
# - Added 500mb as a choice to ISP cap
###2004-0729 - Bandview v0.5 mod by catastrophe
# - Intended for use on Smoothwall Express 2.0 p3 ui-3.6.1
# - Hide zeroes for ipacsum month by anniversary day functional
# - Added ipacsum timeframe and none options in usage summary
# - Added 192_168_0_, 192_168_1_, and 192_168_2_ usernames.
# - Fixed Custom Usage Summary bug
# - Allowed Custom selection of one day
# - Incorporated "DAYS USED mod" contribution by Andrew Brown (andrewb)
# - Added support for the BLUE Interface mod by Daniel Hokka Zakrisson (daniel_hozac)
# - Daily in/out average for current month by anniversary
# - Fixed the selection of ISP Caps 100GB and 200GB (thanks firetone) 
# - Added 250gb options as an ISP Cap option as requested
# - Removed "192.168.0.", "192.168.1.", and "192.168.2." as username choices as the "." causes problems.
###2004-1130 - Bandview v0.6 mod by catastrophe
# - Intended for use on Smoothwall Express 2.0 p4 ui-3.6.1
# - Added "page generated in 'x' seconds" (thanks daniel_hozac)
# - Added 'hide alertbox' variable
# - Added GUI for adding, removing, editting users (some code adapted from dhcp.cgi by The Smoothwall Team)
# - Use of a modified writeipac.pl to read bandview-userlist and generate ipac-ng rules
# - Use of bandviewhelper binary to help run writeipac.pl and fetchipac
# - Added "tabbed" menu (some code adapted from graphs.cgi by The Smoothwall Team)
# - Removed unused "bwbar" subroutine
# - Individualized user cap
# - Fixed initial "user left" from being calculated incorrectly in bandview.pl
# - Reworked page refresh with code by daniel_hozac
# - Added User list sorting, the ip2number routine adapted from the dhcppack mod by Tiago
# - Calculate usage by 'in and out', 'in only', or 'out only'
# - Added commented lines for modsys
###2004-1215 - Bandview v0.6.1 mod by catastrophe
# - Added "hide triple zeroes" option under monthly monitor
# - Fixed "carry over bug" from previous user entry if 'userbandper is less than one' (thanks dunmarie)
###2005-0310 - bandview v0.6.2 mod by catastrophe
# - Intended for use on Smoothwall Express 2.0 fixes6 ui-3.6.1
# - Tweaked so compatible with sylvester's blackcurrant color mod
# - Fixed "proxy rule set although proxy not being used" when monitoring users (thanks daniel_hozac, fluiduk, dob80z)
#
#
# - Known Issues:
#    - "Custom dates" reset when you choose a non-custom view (i.e. 'Today'), then return to 'Custom' view
#
# - Disclaimer:
#    - Use at your own risk without any or implied warranty, etc.
###



############
###HEADER###
############

require '/var/smoothwall/header.pl';

use Time::HiRes qw( gettimeofday );

###############
###VARIABLES###
###############

#$bandusagedatfile="/usr/local/bin/usage.dat"; ###support for usage.pl by Matthew Yager (Unicorn)

&bandviewTABinfo();

#&showhttpheaders();

my (%bandviewsettings,%checked,%selected,%bandviewsettings2,%bandviewsettings4);
$bandviewsettings{'ACTION'} = '';
$bandviewsettings{'BAND_ANNIVERSARY'} = '1';
$bandviewsettings{'BAND_ALLOTTED'} = '10000';
$bandviewsettings{'BAND_CALCULATEWHAT'} = 'both';
$bandviewsettings{'BAND_HIDETRIPLEZEROES'} = 'off';
$bandviewsettings{'BAND_USERNAME'} = 'none';	###leave uncommented for now (formatting)
#$bandviewsettings{'BAND_TABSELECTED'} = '#ffcc66';
$bandviewsettings{'BAND_TABSELECTED'} = $boxcolour;
#$bandviewsettings{'BAND_TABNOTSELECTED'} = '#ffee99';
$bandviewsettings{'BAND_TABNOTSELECTED'} = $primarynavdesel;
$bandviewsettings{'BAND_HIDE_ALERTBOX'} = 'on';
$bandviewsettings{'BAND_USAGEPL'} = '/usr/local/bin/usage.dat'; ###support for usage.pl by Matthew Yager (Unicorn)
$bandviewsettings{'BAND_USERLIST'} = '/var/smoothwall/preferences/bandview-userlist';
$bandviewsettings2{'BAND_SUMMARY'} = 'today';
$bandviewsettings2{'BAND_STARTMONTH'} = '12';
$bandviewsettings2{'BAND_STARTDAY'} = '13';
$bandviewsettings2{'BAND_STARTYEAR'} = '2003';
$bandviewsettings2{'BAND_ENDMONTH'} = '12';
$bandviewsettings2{'BAND_ENDDAY'} = '13';
$bandviewsettings2{'BAND_ENDYEAR'} = '2004';
$bandviewsettings2{'BAND_HIDEZEROES'} = 'off';
$bandviewsettings2{'BAND_REFRESH'} = '0';
$bandviewsettings4{'BAND_COLUMN'} = '0';
$bandviewsettings4{'BAND_REVERSE'} = 'off';
$bandviewsettings4{'BAND_REWRITE'} = 'off';
$bandviewsettings4{'BAND_SORTFILE'} = '/var/smoothwall/preferences/bandview-userlist';
&getcgihash(\%bandviewsettings);

@bandviewtablabel = ("monitor","ipacsum","rules","users");	###bandview tabs!

my $errormessage = '';

&bandviewUSERadd();
&bandviewUSERremoveEDIT();
&bandviewACTIONupdate();

system ("/bin/touch ${swroot}/preferences/bandview");
&readhash("${swroot}/preferences/bandview", \%bandviewsettings);	###first tab (and global) settings

system ("/bin/touch ${swroot}/preferences/bandview2");
&readhash("${swroot}/preferences/bandview2", \%bandviewsettings2);	###second tab settings

system ("/bin/touch ${swroot}/preferences/bandview4");
&readhash("${swroot}/preferences/bandview4", \%bandviewsettings4);	###fourth tab settings

system ("/bin/touch ${swroot}/preferences/bandview-userlist");

for ($i=1; $i < 32; $i++){
$selected{'BAND_ANNIVERSARY'}{$i} = '';
}
$selected{'BAND_ANNIVERSARY'}{$bandviewsettings{'BAND_ANNIVERSARY'}} = 'SELECTED';

$selected{'BAND_ALLOTTED'}{'0'} = '';
$selected{'BAND_ALLOTTED'}{'500'} = '';
$selected{'BAND_ALLOTTED'}{'1000'} = '';
$selected{'BAND_ALLOTTED'}{'2000'} = '';
$selected{'BAND_ALLOTTED'}{'3000'} = '';
$selected{'BAND_ALLOTTED'}{'4000'} = '';
$selected{'BAND_ALLOTTED'}{'5000'} = '';
$selected{'BAND_ALLOTTED'}{'6000'} = '';
$selected{'BAND_ALLOTTED'}{'7000'} = '';
$selected{'BAND_ALLOTTED'}{'8000'} = '';
$selected{'BAND_ALLOTTED'}{'9000'} = '';
$selected{'BAND_ALLOTTED'}{'10000'} = '';
$selected{'BAND_ALLOTTED'}{'11000'} = '';
$selected{'BAND_ALLOTTED'}{'12000'} = '';
$selected{'BAND_ALLOTTED'}{'13000'} = '';
$selected{'BAND_ALLOTTED'}{'14000'} = '';
$selected{'BAND_ALLOTTED'}{'15000'} = '';
$selected{'BAND_ALLOTTED'}{'16000'} = '';
$selected{'BAND_ALLOTTED'}{'17000'} = '';
$selected{'BAND_ALLOTTED'}{'18000'} = '';
$selected{'BAND_ALLOTTED'}{'19000'} = '';
$selected{'BAND_ALLOTTED'}{'20000'} = '';
$selected{'BAND_ALLOTTED'}{'25000'} = '';
$selected{'BAND_ALLOTTED'}{'30000'} = '';
$selected{'BAND_ALLOTTED'}{'35000'} = '';
$selected{'BAND_ALLOTTED'}{'40000'} = '';
$selected{'BAND_ALLOTTED'}{'45000'} = '';
$selected{'BAND_ALLOTTED'}{'50000'} = '';
$selected{'BAND_ALLOTTED'}{'60000'} = '';
$selected{'BAND_ALLOTTED'}{'70000'} = '';
$selected{'BAND_ALLOTTED'}{'80000'} = '';
$selected{'BAND_ALLOTTED'}{'90000'} = '';
$selected{'BAND_ALLOTTED'}{'100000'} = '';
$selected{'BAND_ALLOTTED'}{'200000'} = '';
$selected{'BAND_ALLOTTED'}{'250000'} = '';
$selected{'BAND_ALLOTTED'}{$bandviewsettings{'BAND_ALLOTTED'}} = 'SELECTED';

$selected{'BAND_CALCULATEWHAT'}{'both'} = '';
$selected{'BAND_CALCULATEWHAT'}{'inonly'} = '';
$selected{'BAND_CALCULATEWHAT'}{'outonly'} = '';
$selected{'BAND_CALCULATEWHAT'}{$bandviewsettings{'BAND_CALCULATEWHAT'}} = 'SELECTED';

$checked{'BAND_HIDETRIPLEZEROES'}{'on'} = '';
$checked{'BAND_HIDETRIPLEZEROES'}{'off'} = '';
$checked{'BAND_HIDETRIPLEZEROES'}{$bandviewsettings{'BAND_HIDETRIPLEZEROES'}} = 'CHECKED';

$selected{'BAND_SUMMARY'}{'none'} = '';
$selected{'BAND_SUMMARY'}{'today'} = '';
$selected{'BAND_SUMMARY'}{'yesterday'} = '';
$selected{'BAND_SUMMARY'}{'week'} = '';
$selected{'BAND_SUMMARY'}{'lastweek'} = '';
$selected{'BAND_SUMMARY'}{'month'} = '';
$selected{'BAND_SUMMARY'}{'anniversary'} = '';
$selected{'BAND_SUMMARY'}{'lastmonth'} = '';
$selected{'BAND_SUMMARY'}{'year'} = '';
$selected{'BAND_SUMMARY'}{'lastyear'} = '';
$selected{'BAND_SUMMARY'}{'all'} = '';
$selected{'BAND_SUMMARY'}{'timeframe'} = '';
$selected{'BAND_SUMMARY'}{$bandviewsettings2{'BAND_SUMMARY'}} = 'SELECTED';

$selected{'BAND_REFRESH'}{'0'} = '';
$selected{'BAND_REFRESH'}{'5'} = '';
$selected{'BAND_REFRESH'}{'10'} = '';
$selected{'BAND_REFRESH'}{'30'} = '';
$selected{'BAND_REFRESH'}{'60'} = '';
$selected{'BAND_REFRESH'}{'120'} = '';
$selected{'BAND_REFRESH'}{'300'} = '';
$selected{'BAND_REFRESH'}{'600'} = '';
$selected{'BAND_REFRESH'}{'1800'} = '';
$selected{'BAND_REFRESH'}{'3600'} = '';
$selected{'BAND_REFRESH'}{$bandviewsettings2{'BAND_REFRESH'}} = 'SELECTED';

$checked{'BAND_HIDEZEROES'}{'on'} = '';
$checked{'BAND_HIDEZEROES'}{'off'} = '';
$checked{'BAND_HIDEZEROES'}{$bandviewsettings2{'BAND_HIDEZEROES'}} = 'CHECKED';

if ($bandviewsettings2{'BAND_SUMMARY'} eq 'custom') {
	$selected{'BAND_STARTMONTH'}{'01'} = '';
	$selected{'BAND_STARTMONTH'}{'02'} = '';
	$selected{'BAND_STARTMONTH'}{'03'} = '';
	$selected{'BAND_STARTMONTH'}{'04'} = '';
	$selected{'BAND_STARTMONTH'}{'05'} = '';
	$selected{'BAND_STARTMONTH'}{'06'} = '';
	$selected{'BAND_STARTMONTH'}{'07'} = '';
	$selected{'BAND_STARTMONTH'}{'08'} = '';
	$selected{'BAND_STARTMONTH'}{'09'} = '';
	$selected{'BAND_STARTMONTH'}{'10'} = '';
	$selected{'BAND_STARTMONTH'}{'11'} = '';
	$selected{'BAND_STARTMONTH'}{'12'} = '';
	$selected{'BAND_STARTMONTH'}{$bandviewsettings2{'BAND_STARTMONTH'}} = 'SELECTED';

	$selected{'BAND_STARTDAY'}{'01'} = '';
	$selected{'BAND_STARTDAY'}{'02'} = '';
	$selected{'BAND_STARTDAY'}{'03'} = '';
	$selected{'BAND_STARTDAY'}{'04'} = '';
	$selected{'BAND_STARTDAY'}{'05'} = '';
	$selected{'BAND_STARTDAY'}{'06'} = '';
	$selected{'BAND_STARTDAY'}{'07'} = '';
	$selected{'BAND_STARTDAY'}{'08'} = '';
	$selected{'BAND_STARTDAY'}{'09'} = '';
	for ($i=10; $i < 32; $i++){
	$selected{'BAND_STARTDAY'}{$i} = '';
	}
	$selected{'BAND_STARTDAY'}{$bandviewsettings2{'BAND_STARTDAY'}} = 'SELECTED';

	for ($i=2000; $i < 2011; $i++){
	$selected{'BAND_STARTYEAR'}{$i} = '';
	}
	$selected{'BAND_STARTYEAR'}{$bandviewsettings2{'BAND_STARTYEAR'}} = 'SELECTED';

	$selected{'BAND_ENDMONTH'}{'01'} = '';
	$selected{'BAND_ENDMONTH'}{'02'} = '';
	$selected{'BAND_ENDMONTH'}{'03'} = '';
	$selected{'BAND_ENDMONTH'}{'04'} = '';
	$selected{'BAND_ENDMONTH'}{'05'} = '';
	$selected{'BAND_ENDMONTH'}{'06'} = '';
	$selected{'BAND_ENDMONTH'}{'07'} = '';
	$selected{'BAND_ENDMONTH'}{'08'} = '';
	$selected{'BAND_ENDMONTH'}{'09'} = '';
	$selected{'BAND_ENDMONTH'}{'10'} = '';
	$selected{'BAND_ENDMONTH'}{'11'} = '';
	$selected{'BAND_ENDMONTH'}{'12'} = '';
	$selected{'BAND_ENDMONTH'}{$bandviewsettings2{'BAND_ENDMONTH'}} = 'SELECTED';

	$selected{'BAND_ENDDAY'}{'01'} = '';
	$selected{'BAND_ENDDAY'}{'02'} = '';
	$selected{'BAND_ENDDAY'}{'03'} = '';
	$selected{'BAND_ENDDAY'}{'04'} = '';
	$selected{'BAND_ENDDAY'}{'05'} = '';
	$selected{'BAND_ENDDAY'}{'06'} = '';
	$selected{'BAND_ENDDAY'}{'07'} = '';
	$selected{'BAND_ENDDAY'}{'08'} = '';
	$selected{'BAND_ENDDAY'}{'09'} = '';
	for ($i=10; $i < 32; $i++){
	$selected{'BAND_ENDDAY'}{$i} = '';
	}
	$selected{'BAND_ENDDAY'}{$bandviewsettings2{'BAND_ENDDAY'}} = 'SELECTED';

	for ($i=2000; $i < 2011; $i++){
	$selected{'BAND_ENDYEAR'}{$i} = '';
	}
	$selected{'BAND_ENDYEAR'}{$bandviewsettings2{'BAND_ENDYEAR'}} = 'SELECTED';
}

$selected{'BAND_COLUMN'}{'0'} = '';
$selected{'BAND_COLUMN'}{'1'} = '';
$selected{'BAND_COLUMN'}{'2'} = '';
$selected{'BAND_COLUMN'}{'3'} = '';
$selected{'BAND_COLUMN'}{'4'} = '';
$selected{'BAND_COLUMN'}{$bandviewsettings4{'BAND_COLUMN'}} = 'SELECTED';

$checked{'BAND_REVERSE'}{'on'} = '';
$checked{'BAND_REVERSE'}{'off'} = '';
$checked{'BAND_REVERSE'}{$bandviewsettings4{'BAND_REVERSE'}} = 'CHECKED';

$checked{'BAND_REWRITE'}{'on'} = '';
$checked{'BAND_REWRITE'}{'off'} = '';
$checked{'BAND_REWRITE'}{$bandviewsettings4{'BAND_REWRITE'}} = 'CHECKED';

&bandviewREFRESHset();

&showaboutsection();
#&showmodssection();	###modsys

&openbigbox('100%', 'LEFT');

if ($bandviewsettings{'BAND_HIDE_ALERTBOX'} eq 'on') {	###hide alertbox, but show error message
	if ($errormessage ne '') {
		print qq|
		<table border='0' cellpadding='3' cellspacing='0' width="100%">
		<TR><TD valign='top' align='center'><font color='#FF000'>ERROR: $errormessage</font></TD></TR>
		</TABLE>
		|;
	}
} else {
	&alertbox($errormessage);
}

##########
###MAIN###
##########

&bandviewMAINmenuZERO();

if ($bandviewtabnumber eq '3') {
&bandviewMAINmenuTHREE();
} elsif ($bandviewtabnumber eq '2') {
&bandviewMAINmenuTWO();
} elsif ($bandviewtabnumber eq '4') {
&bandviewMAINmenuFOUR();
} else {
&bandviewMAINmenuONE();
}

&closebigbox();
&closepage();

$t1 = gettimeofday(); $t2=$t1-$t0;
print "<PRE><center>Page generated in ", sprintf ('%.2f', $t2), " seconds.</center></PRE>";


##########
###DONE###
##########







#################
###SUBROUTINES###
#################


sub bandviewMAINmenuZERO {	###bandview tabs!
	print "<TABLE border='0' cellspacing='0' cellpadding='0'>";
	for ($i=0; $i <= $#bandviewtablabel; $i++) {
		$j=$i+1;
		if ($bandviewtabnumber == $j) {
			$bandtabcolor=$bandviewsettings{'BAND_TABSELECTED'};
		} elsif (($bandviewtabnumber == '') && ($j == 1)) {
			$bandtabcolor=$bandviewsettings{'BAND_TABSELECTED'};
		} else {
			$bandtabcolor=$bandviewsettings{'BAND_TABNOTSELECTED'};
		}
		print qq|
		<td bgcolor="$bandtabcolor" align="center">
		<img src="/ui/assets/3.5/img/null.gif" width="50" height="3" alt=""><br>&nbsp; <a href="/cgi-bin/bandview.cgi?t=$j">$bandviewtablabel[$i]</a> &nbsp;<br>
		<img src="/ui/assets/3.5/img/null.gif" width="50" height="3" alt=""></td>
		<td width=7><img src="/ui/assets/3.5/img/null.gif" width="7" height="1" alt="&nbsp;"></td>
		|;
	}
	print "</table>";
}


sub bandviewMAINmenuONE {
	&openbox('100%', 'LEFT', $tr{'band monitorc'});
	print "<FORM METHOD='POST'>\n";

	print qq|
	<TABLE WIDTH='100%'>
	<TR>
       <TD CLASS='base'>$tr{'band anniversaryc'}
	<SELECT NAME='BAND_ANNIVERSARY'>
	|;
	for ($i=1; $i < 32; $i++){
		print "<OPTION VALUE='$i' $selected{'BAND_ANNIVERSARY'}{$i}>$i";
	}
	print qq|
       </SELECT>   

	<TD CLASS='base'>$tr{'band allottedc'}
	<SELECT NAME='BAND_ALLOTTED'>
		<OPTION VALUE='0' $selected{'BAND_ALLOTTED'}{'0'}>None
		<OPTION VALUE='500' $selected{'BAND_ALLOTTED'}{'500'}>.5 G
		<OPTION VALUE='1000' $selected{'BAND_ALLOTTED'}{'1000'}>1 G
		<OPTION VALUE='2000' $selected{'BAND_ALLOTTED'}{'2000'}>2 G
		<OPTION VALUE='3000' $selected{'BAND_ALLOTTED'}{'3000'}>3 G
		<OPTION VALUE='4000' $selected{'BAND_ALLOTTED'}{'4000'}>4 G
		<OPTION VALUE='5000' $selected{'BAND_ALLOTTED'}{'5000'}>5 G
		<OPTION VALUE='6000' $selected{'BAND_ALLOTTED'}{'6000'}>6 G
		<OPTION VALUE='7000' $selected{'BAND_ALLOTTED'}{'7000'}>7 G
		<OPTION VALUE='8000' $selected{'BAND_ALLOTTED'}{'8000'}>8 G
		<OPTION VALUE='9000' $selected{'BAND_ALLOTTED'}{'9000'}>9 G
		<OPTION VALUE='10000' $selected{'BAND_ALLOTTED'}{'10000'}>10 G
		<OPTION VALUE='11000' $selected{'BAND_ALLOTTED'}{'11000'}>11 G
		<OPTION VALUE='12000' $selected{'BAND_ALLOTTED'}{'12000'}>12 G
		<OPTION VALUE='13000' $selected{'BAND_ALLOTTED'}{'13000'}>13 G
		<OPTION VALUE='14000' $selected{'BAND_ALLOTTED'}{'14000'}>14 G
		<OPTION VALUE='15000' $selected{'BAND_ALLOTTED'}{'15000'}>15 G
		<OPTION VALUE='16000' $selected{'BAND_ALLOTTED'}{'16000'}>16 G
		<OPTION VALUE='17000' $selected{'BAND_ALLOTTED'}{'17000'}>17 G
		<OPTION VALUE='18000' $selected{'BAND_ALLOTTED'}{'18000'}>18 G
		<OPTION VALUE='19000' $selected{'BAND_ALLOTTED'}{'19000'}>19 G
		<OPTION VALUE='20000' $selected{'BAND_ALLOTTED'}{'20000'}>20 G
       	<OPTION VALUE='25000' $selected{'BAND_ALLOTTED'}{'25000'}>25 G
		<OPTION VALUE='30000' $selected{'BAND_ALLOTTED'}{'30000'}>30 G
		<OPTION VALUE='35000' $selected{'BAND_ALLOTTED'}{'35000'}>35 G
		<OPTION VALUE='40000' $selected{'BAND_ALLOTTED'}{'40000'}>40 G
		<OPTION VALUE='45000' $selected{'BAND_ALLOTTED'}{'45000'}>45 G
		<OPTION VALUE='50000' $selected{'BAND_ALLOTTED'}{'50000'}>50 G
		<OPTION VALUE='60000' $selected{'BAND_ALLOTTED'}{'60000'}>60 G
		<OPTION VALUE='70000' $selected{'BAND_ALLOTTED'}{'70000'}>70 G
		<OPTION VALUE='80000' $selected{'BAND_ALLOTTED'}{'80000'}>80 G
		<OPTION VALUE='90000' $selected{'BAND_ALLOTTED'}{'90000'}>90 G
		<OPTION VALUE='100000' $selected{'BAND_ALLOTTED'}{'100000'}>100 G
		<OPTION VALUE='200000' $selected{'BAND_ALLOTTED'}{'200000'}>200 G
		<OPTION VALUE='250000' $selected{'BAND_ALLOTTED'}{'250000'}>250 G
       </SELECT>

	<TD CLASS='base'>$tr{'band calculateusagec'}
	<SELECT NAME='BAND_CALCULATEWHAT'>
		<OPTION VALUE='both' $selected{'BAND_CALCULATEWHAT'}{'both'}>In and Out
		<OPTION VALUE='inonly' $selected{'BAND_CALCULATEWHAT'}{'inonly'}>In Only
		<OPTION VALUE='outonly' $selected{'BAND_CALCULATEWHAT'}{'outonly'}>Out Only
       </SELECT>

	<TD WIDTH CLASS='base'>$tr{'band hidezeroesc'}<INPUT TYPE='checkbox' NAME='BAND_HIDETRIPLEZEROES' $checked{'BAND_HIDETRIPLEZEROES'}{'on'}></TD>

	<TD WIDTH='10%' ALIGN='CENTER'><INPUT TYPE='submit' NAME='ACTION' VALUE='$tr{'band apply'}'></TD>
	</TR>
	</TABLE>
	|;

	print "<PRE>";
	system ('/usr/local/bin/bandview.pl');
	print "</PRE>";

	if ($bandviewsettings{'BAND_USERNAME'} ne 'none') {
		print "</tr></table>";
	} else {
		###do nothing
	}
	&closebox();
}


sub bandviewMAINmenuTWO {
	&openbox('100%', 'LEFT', $tr{'band usageviewerc'});
	print "<FORM METHOD='POST'>\n";

	print qq|
	<TABLE WIDTH='100%'>
	<TR>
	<TD WIDTH='20%' CLASS='base'>$tr{'band summaryc'}
	<SELECT NAME='BAND_SUMMARY'>
		<OPTION VALUE='none' $selected{'BAND_SUMMARY'}{'none'}>None
		<OPTION VALUE='today' $selected{'BAND_SUMMARY'}{'today'}>Today
		<OPTION VALUE='yesterday' $selected{'BAND_SUMMARY'}{'yesterday'}>Yesterday
		<OPTION VALUE='this week' $selected{'BAND_SUMMARY'}{'this week'}>This Week
	       <OPTION VALUE='last week' $selected{'BAND_SUMMARY'}{'last week'}>Last Week
		<OPTION VALUE='this month' $selected{'BAND_SUMMARY'}{'this month'}>This Month
      		<OPTION VALUE='anniversary' $selected{'BAND_SUMMARY'}{'anniversary'}>This Month*    
	       <OPTION VALUE='last month' $selected{'BAND_SUMMARY'}{'last month'}>Last Month
		<OPTION VALUE='this year' $selected{'BAND_SUMMARY'}{'this year'}>This Year
	       <OPTION VALUE='last year' $selected{'BAND_SUMMARY'}{'last year'}>Last Year
	       <OPTION VALUE='all' $selected{'BAND_SUMMARY'}{'all'}>All
	       <OPTION VALUE='custom' $selected{'BAND_SUMMARY'}{'custom'}>Custom
	</SELECT>

	<TD WIDTH='7%' CLASS='base'>$tr{'band hidezeroesc'}</TD>
	<TD WIDTH='5%'><INPUT TYPE='checkbox' NAME='BAND_HIDEZEROES' $checked{'BAND_HIDEZEROES'}{'on'}></TD>

	<TD WIDTH='15%' CLASS='base'>$tr{'band refreshc'}
	<SELECT NAME='BAND_REFRESH'>
	       <OPTION VALUE='0' $selected{'BAND_REFRESH'}{'0'}>Off
		<OPTION VALUE='30' $selected{'BAND_REFRESH'}{'30'}>30s
		<OPTION VALUE='300' $selected{'BAND_REFRESH'}{'300'}>300s
	       <OPTION VALUE='600' $selected{'BAND_REFRESH'}{'600'}>600s
        	<OPTION VALUE='1800' $selected{'BAND_REFRESH'}{'1800'}>1800s
        	<OPTION VALUE='3600' $selected{'BAND_REFRESH'}{'3600'}>3600s
	</SELECT>
       </TD>
	
	<TD WIDTH='10%' ALIGN='CENTER'><INPUT TYPE='submit' NAME='ACTION' VALUE='$tr{'update'}'></TD>

	</TR>
	</TABLE>
	|;

	if ($bandviewsettings2{'BAND_SUMMARY'} eq 'custom') {
		print qq|
		<TABLE WIDTH='100%'>
		<TR>

		<TD CLASS='base'>$tr{'band startdatec'}
		<SELECT NAME='BAND_STARTMONTH'>
			<OPTION VALUE='01' $selected{'BAND_STARTMONTH'}{'01'}>01
			<OPTION VALUE='02' $selected{'BAND_STARTMONTH'}{'02'}>02
			<OPTION VALUE='03' $selected{'BAND_STARTMONTH'}{'03'}>03
			<OPTION VALUE='04' $selected{'BAND_STARTMONTH'}{'04'}>04
			<OPTION VALUE='05' $selected{'BAND_STARTMONTH'}{'05'}>05
			<OPTION VALUE='06' $selected{'BAND_STARTMONTH'}{'06'}>06
			<OPTION VALUE='07' $selected{'BAND_STARTMONTH'}{'07'}>07
			<OPTION VALUE='08' $selected{'BAND_STARTMONTH'}{'08'}>08
			<OPTION VALUE='09' $selected{'BAND_STARTMONTH'}{'09'}>09
			<OPTION VALUE='10' $selected{'BAND_STARTMONTH'}{'10'}>10
			<OPTION VALUE='11' $selected{'BAND_STARTMONTH'}{'11'}>11
			<OPTION VALUE='12' $selected{'BAND_STARTMONTH'}{'12'}>12
		</SELECT>

		<SELECT NAME='BAND_STARTDAY'>
			<OPTION VALUE='01' $selected{'BAND_STARTDAY'}{'01'}>01
			<OPTION VALUE='02' $selected{'BAND_STARTDAY'}{'02'}>02
			<OPTION VALUE='03' $selected{'BAND_STARTDAY'}{'03'}>03
			<OPTION VALUE='04' $selected{'BAND_STARTDAY'}{'04'}>04
			<OPTION VALUE='05' $selected{'BAND_STARTDAY'}{'05'}>05
			<OPTION VALUE='06' $selected{'BAND_STARTDAY'}{'06'}>06
			<OPTION VALUE='07' $selected{'BAND_STARTDAY'}{'07'}>07
			<OPTION VALUE='08' $selected{'BAND_STARTDAY'}{'08'}>08
			<OPTION VALUE='09' $selected{'BAND_STARTDAY'}{'09'}>09
		|;
		for ($i=10; $i < 32; $i++){
			print "<OPTION VALUE='$i' $selected{'BAND_STARTDAY'}{$i}>$i";
		}
		print qq|
		</SELECT>

		<SELECT NAME='BAND_STARTYEAR'>
		|;
		for ($i=2000; $i < 2011; $i++){
			print "<OPTION VALUE='$i' $selected{'BAND_STARTYEAR'}{$i}>$i";
		}
		print qq|
		</SELECT>
		</TD>

		<TD CLASS='base'>$tr{'band enddatec'}
		<SELECT NAME='BAND_ENDMONTH'>
			<OPTION VALUE='01' $selected{'BAND_ENDMONTH'}{'01'}>01
			<OPTION VALUE='02' $selected{'BAND_ENDMONTH'}{'02'}>02
			<OPTION VALUE='03' $selected{'BAND_ENDMONTH'}{'03'}>03
			<OPTION VALUE='04' $selected{'BAND_ENDMONTH'}{'04'}>04
			<OPTION VALUE='05' $selected{'BAND_ENDMONTH'}{'05'}>05
			<OPTION VALUE='06' $selected{'BAND_ENDMONTH'}{'06'}>06
			<OPTION VALUE='07' $selected{'BAND_ENDMONTH'}{'07'}>07
			<OPTION VALUE='08' $selected{'BAND_ENDMONTH'}{'08'}>08
			<OPTION VALUE='09' $selected{'BAND_ENDMONTH'}{'09'}>09
			<OPTION VALUE='10' $selected{'BAND_ENDMONTH'}{'10'}>10
			<OPTION VALUE='11' $selected{'BAND_ENDMONTH'}{'11'}>11
			<OPTION VALUE='12' $selected{'BAND_ENDMONTH'}{'12'}>12
		</SELECT>

		<SELECT NAME='BAND_ENDDAY'>
			<OPTION VALUE='01' $selected{'BAND_ENDDAY'}{'01'}>01
			<OPTION VALUE='02' $selected{'BAND_ENDDAY'}{'02'}>02
			<OPTION VALUE='03' $selected{'BAND_ENDDAY'}{'03'}>03
			<OPTION VALUE='04' $selected{'BAND_ENDDAY'}{'04'}>04
			<OPTION VALUE='05' $selected{'BAND_ENDDAY'}{'05'}>05
			<OPTION VALUE='06' $selected{'BAND_ENDDAY'}{'06'}>06
			<OPTION VALUE='07' $selected{'BAND_ENDDAY'}{'07'}>07
			<OPTION VALUE='08' $selected{'BAND_ENDDAY'}{'08'}>08
			<OPTION VALUE='09' $selected{'BAND_ENDDAY'}{'09'}>09
		|;
		for ($i=10; $i < 32; $i++){
			print "<OPTION VALUE='$i' $selected{'BAND_ENDDAY'}{$i}>$i";
		}
		print qq|
		</SELECT>

		<SELECT NAME='BAND_ENDYEAR'>
		|;
		for ($i=2000; $i < 2011; $i++){
			print "<OPTION VALUE='$i' $selected{'BAND_ENDYEAR'}{$i}>$i";
		}
		print qq|
		</SELECT>
		</TD>

		</TR>
		</TABLE>
		|;
	}
	&bandDISPLAYusagesummary();
	&closebox();
}


sub bandviewMAINmenuTHREE {
	&openbox('100%', 'LEFT', $tr{'band currentrulesc'});
	@ipacrules = `cat /etc/ipac-ng/ipac.rules`;
#	print "<BR><TABLE><TR><TD align='right'><B>#</B></TD><TD>&nbsp;</TD><TD><B>$tr{'band rules'}</B></TD>";
	print qq|
	<BR><TABLE><TR>
	<TD align='right'><B>#</B></TD>
	<TD>&nbsp;</TD>
	<td style='cursor: pointer' title="name of rule &#124 direction &#124 interface &#124 protocol &#124 source &#124 destination &#124 extension&#124"><B>$tr{'band rules'}</B></TD>
	|;

	for ($i=0; $i <= $#ipacrules; $i++){
		chomp ($ipacrules[$i]);
		print qq|
		<TR>
		<TD align="right">$i</TD><TD>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
		<TD><TT>$ipacrules[$i]</TT></TD>
		</TR>
		|;
	}
	print "</TABLE>";
	&closebox;
}


sub bandviewMAINmenuFOUR {
	&openbox('100%', 'LEFT', $tr{'band addusersc'});
	print qq|
	<FORM METHOD='POST'>
	<TABLE WIDTH='100%'>
	<TR>
	<TD CLASS='base'>$tr{'username'} <INPUT TYPE='text' NAME='BAND_COMPUTERNAME' SIZE=16 MAXLENGTH=15 VALUE='$bandviewsettings{'BAND_COMPUTERNAME'}'></TD>
	<TD CLASS='base'>$tr{'ip addressc'} <INPUT TYPE='text' NAME='BAND_COMPUTERIP' SIZE=15 MAXLENGTH=15 VALUE='$bandviewsettings{'BAND_COMPUTERIP'}'></TD>
	<TD CLASS='base'>$tr{'band usercapc'} <INPUT TYPE='text' NAME='BAND_INDIVIDUALCAP' SIZE=6 MAXLENGTH=6 VALUE='$bandviewsettings{'BAND_INDIVIDUALCAP'}'></TD>
	<TD CLASS='base'>$tr{'descriptionc'} <INPUT TYPE='text' NAME='BAND_USERCOMMENT' SIZE=21 MAXLENGTH=20 VALUE='$bandviewsettings{'BAND_USERCOMMENT'}'></TD>
	<TD WIDTH='5%' ALIGN='RIGHT' COLSPAN='2'><INPUT TYPE='submit' NAME='ACTION' VALUE='$tr{'add'}'></TD>
	</TR>
	</TABLE>
	|;
	&closebox();

	&openbox('100%', 'LEFT', $tr{'band currentuserlistc'});
	if (-e $bandviewsettings{'BAND_USERLIST'}) {
		@bandviewusers = `cat $bandviewsettings{'BAND_USERLIST'}`;
		chomp (@bandviewusers);
	}
	print qq|
	<TABLE WIDTH='100%'>

<TD CLASS='base'>$tr{'band sortbyc'}
	<SELECT NAME='BAND_COLUMN'>
		<OPTION VALUE='0' $selected{'BAND_COLUMN'}{'0'}>None
		<OPTION VALUE='1' $selected{'BAND_COLUMN'}{'1'}>Username
		<OPTION VALUE='5' $selected{'BAND_COLUMN'}{'5'}>IP Address
		<OPTION VALUE='3' $selected{'BAND_COLUMN'}{'3'}>User Cap
		<OPTION VALUE='4' $selected{'BAND_COLUMN'}{'4'}>Description
	</SELECT>
	</TD>

	<TD CLASS='base'>$tr{'band reversesortc'}
	<INPUT TYPE='checkbox' NAME='BAND_REVERSE' $checked{'BAND_REVERSE'}{'on'}>
	</TD>

	<TD CLASS='base'>$tr{'band rewriterulesc'}
	<INPUT TYPE='checkbox' NAME='BAND_REWRITE' $checked{'BAND_REWRITE'}{'on'}>
	</TD>

	<TD ALIGN='RIGHT'><INPUT TYPE='submit' NAME='ACTION' VALUE='$tr{'band refresh'}'></TD>
</TABLE>

	<TABLE WIDTH='100%'>
	<BR>
	<TR>
	<TD WIDTH='25%' ALIGN='CENTER'><b>$tr{'band username'}<b></TD>
	<TD WIDTH='25%' ALIGN='CENTER'><b>$tr{'ip address'}<b></TD>
	<TD WIDTH='25%' ALIGN='CENTER'><b>$tr{'band individualcap'}<b></TD>
	<TD WIDTH='25%' ALIGN='CENTER'><b>$tr{'description'}<b></TD>
	<TD WIDTH='5%' ALIGN='CENTER'><b>$tr{'mark'}<b></TD>
	</TR>
	|;

	if (-e $bandviewsettings{'BAND_USERLIST'}) {
		###START###some code adapted from dhcp.cgi by The Smoothwall Team
		my $id = 0;
		open(USERLIST, "$bandviewsettings{'BAND_USERLIST'}") or die 'Unable to open config file.';
		while (<USERLIST>)
		{
			$id++;
			chomp($_);
			my @temp = split(/\,/,$_);
			if ($id % 2) {
				print "<TR BGCOLOR='$table1colour'>\n"; }
			else {
				print "<TR BGCOLOR='$table2colour'>\n"; }
			print qq|
			<TD ALIGN='CENTER'>$temp[0]</TD>
			<TD ALIGN='CENTER'>$temp[1]</TD>
			<TD ALIGN='CENTER'>$temp[2]</TD>
			<TD ALIGN='CENTER'>$temp[3]</TD>
			<TD ALIGN='CENTER'><INPUT TYPE='CHECKBOX' NAME='$id'></TD>
			</TR>
			|;
		}
		close(USERLIST);
		###END###some code adapted from dhcp.cgi by The Smoothwall Team
	}
	print qq|
	</TABLE>
	<TABLE WIDTH='100%'>
	<TR>
	<TD WIDTH='50%' ALIGN='CENTER'><INPUT TYPE='SUBMIT' NAME='ACTION' VALUE='$tr{'remove'}'></TD>
	<TD WIDTH='50%' ALIGN='CENTER'><INPUT TYPE='SUBMIT' NAME='ACTION' VALUE='$tr{'edit'}'></TD>
	</TR>
	</TABLE>
	</FORM>
	|;
	&closebox();
}


sub bandDISPLAYusagesummary {
	$bandviewsummary = $bandviewsettings2{'BAND_SUMMARY'};
	$bandviewstartdate = "$bandviewsettings2{'BAND_STARTYEAR'}$bandviewsettings2{'BAND_STARTMONTH'}$bandviewsettings2{'BAND_STARTDAY'}";
	$bandviewenddate = "$bandviewsettings2{'BAND_ENDYEAR'}$bandviewsettings2{'BAND_ENDMONTH'}$bandviewsettings2{'BAND_ENDDAY'}";
	$bandviewzero="";
	$bandviewstarttime="000000";	###default
	$bandviewendtime="235959";		###default
	$bandviewstart="$bandviewstartdate$bandviewstarttime";
	$bandviewend="$bandviewenddate$bandviewendtime";

	print "<PRE>"; 
	if ($bandviewsettings2{'BAND_HIDEZEROES'} eq 'on') { $bandviewzero="-z"; }

	if ($bandviewsettings2{'BAND_SUMMARY'} eq 'none') {			###none
		###then do nothing
	} elsif ($bandviewsettings2{'BAND_SUMMARY'} eq 'all') {		###all
		system ('/usr/local/sbin/ipacsum', '--fixed-quantity', 'M', $bandviewzero);
	} elsif ($bandviewsettings2{'BAND_SUMMARY'} eq 'custom') {		###custom timeframe
		system ('/usr/local/sbin/ipacsum', '--starttime', $bandviewstart, '--endtime', $bandviewend, '--fixed-quantity', 'M', $bandviewzero);
	} elsif ($bandviewsettings2{'BAND_SUMMARY'} eq 'anniversary') {	###anniversary
		if ($bandviewsettings2{'BAND_HIDEZEROES'} eq 'on') {
			@daystats = `cat /var/lib/ipac/ipacsum.thisperiod.stats`;
			for ($v=0; $v <= $#daystats; $v++) { 
				if ($daystats[$v] =~ / 0M$/){ 
					###do nothing 
				} else { 
					print "$daystats[$v]"; 
				}
			}
		} else {
       		system ('cat /var/lib/ipac/ipacsum.thisperiod.stats');
		}
	} else {									###timeframe
		system ('/usr/local/sbin/ipacsum', '-t', $bandviewsummary, '--fixed-quantity', 'M', $bandviewzero);
	}
#	print "</PRE>\n";
	print "</PRE>";
}


sub bandviewREFRESHset {
	my $refresh = $bandviewsettings2{'BAND_REFRESH'};
	if ($refresh > 0)
	{
		print "Refresh: $refresh\n";
		print "Cache-Control: no-cache\n";
		print "Pragma: no-cache\n";
	}
	&showhttpheaders();
	$t0 = gettimeofday();
	&openpage($tr{'band usageinformation'}, 1, '', 'about your smoothie');
#	&openpage($tr{'band usageinformation'}, 1, '', 'mods');	###modsys
}


sub bandviewUSERadd {	###code adapted from dhcp.cgi by The Smoothwall Team
	if ($bandviewsettings{'ACTION'} eq $tr{'add'}) {
		unless ($bandviewsettings{'BAND_COMPUTERNAME'}) { $errormessage = "please enter a username"; }
		unless ($bandviewsettings{'BAND_COMPUTERNAME'} =~ /^\w+$/) { $errormessage = "username contains bad characters"; }
		if ($bandviewsettings{'BAND_COMPUTERNAME'} =~ /[\,\n]/) { $errormessage = "username contains bad characters"; }
		if ($bandviewsettings{'BAND_COMPUTERNAME'} =~ /[\.\n]/) { $errormessage = "username contains bad characters"; }
		unless(&validip($bandviewsettings{'BAND_COMPUTERIP'})) { $errormessage = $tr{'ip address not valid'}; }
		unless ($bandviewsettings{'BAND_INDIVIDUALCAP'} =~ /^\d+$/) { $errormessage = "user cap can only contain numbers"; }		if ($bandviewsettings{'BAND_INDIVIDUALCAP'} =~ /[\,\n]/) { $errormessage = "user cap contains bad characters"; }
		if ($bandviewsettings{'BAND_INDIVIDUALCAP'} =~ /[\.\n]/) { $errormessage = "user cap contains bad characters"; }
		unless ($bandviewsettings{'BAND_USERCOMMENT'} =~ /^([a-zA-Z])+([\.a-zA-Z0-9_-])+$/) { $errormessage = "description contains bad characters"; }
		if ($bandviewsettings{'BAND_USERCOMMENT'} =~ /[\,\n]/) { $errormessage = "description contains bad characters"; }
		unless ($errormessage) {
			open(FILE, ">>$bandviewsettings{'BAND_USERLIST'}") or die 'Unable to open userlist file.';
			flock FILE, 2;
			print FILE "$bandviewsettings{'BAND_COMPUTERNAME'},$bandviewsettings{'BAND_COMPUTERIP'},$bandviewsettings{'BAND_INDIVIDUALCAP'},$bandviewsettings{'BAND_USERCOMMENT'},".&ip2number($bandviewsettings{'BAND_COMPUTERIP'})."\n";
			close(FILE);
			delete $bandviewsettings{'BAND_COMPUTERNAME'};
			delete $bandviewsettings{'BAND_COMPUTERIP'};
			delete $bandviewsettings{'BAND_INDIVIDUALCAP'};
			delete $bandviewsettings{'BAND_USERCOMMENT'};
			system ("/usr/local/bin/bandviewhelper >/dev/null");
#			system ("$sudo ${swroot}/modsys/helper.d/bandview");	###modsys
		}
	}
}


sub bandviewUSERremoveEDIT {	###some code adapted from dhcp.cgi by The Smoothwall Team
	if ($bandviewsettings{'ACTION'} eq $tr{'remove'} || $bandviewsettings{'ACTION'} eq $tr{'edit'}) 
	{
		open(FILE, "$bandviewsettings{'BAND_USERLIST'}") or die 'Unable to open config file.';
		my @current = <FILE>;
		close(FILE);

		my $count = 0;
		my $id = 0;
		my $line;
		foreach $line (@current)
		{
			$id++;
			if ($bandviewsettings{$id} eq "on") {
				$count++; }
		}
		if ($count == 0) {
			$errormessage = $tr{'nothing selected'}; }
		if ($count > 1 && $bandviewsettings{'ACTION'} eq $tr{'edit'}) {
			$errormessage = $tr{'you can only select one item to edit'}; }
		unless ($errormessage)
		{
			open(USERLIST, ">$bandviewsettings{'BAND_USERLIST'}") or die 'Unable to open config file.';
			flock USERLIST, 2;
 			$id = 0;
			foreach $line (@current)
			{
				$id++;
				unless ($bandviewsettings{$id} eq "on") {
					print USERLIST "$line"; }
				elsif ($bandviewsettings{'ACTION'} eq $tr{'edit'})
				{
					chomp($line);
					my @temp = split(/\,/,$line);
					$bandviewsettings{'BAND_COMPUTERNAME'} = $temp[0];
					$bandviewsettings{'BAND_COMPUTERIP'} = $temp[1];
					$bandviewsettings{'BAND_INDIVIDUALCAP'} = $temp[2];
					$bandviewsettings{'BAND_USERCOMMENT'} = $temp[3];
				}
			}
			close(USERLIST);
			system ("/usr/local/bin/bandviewhelper >/dev/null");
#			system ("$sudo ${swroot}/modsys/helper.d/bandview");	###modsys
		}
	}
}


sub bandviewACTIONupdate {
	if ($bandviewsettings{'ACTION'} eq "Apply") {
		&writehash("${swroot}/preferences/bandview", \%bandviewsettings);
		&bandviewUPDATEusagepl();
	}
	if ($bandviewsettings{'ACTION'} eq $tr{'update'}) {
		&writehash("${swroot}/preferences/bandview2", \%bandviewsettings);
	}
	if ($bandviewsettings{'ACTION'} eq "Refresh") {
		&bandviewSORTING();
#		$bandviewsettings{'BAND_COLUMN'} = '0';	###default back to NOT SORTING after sorting
		if ($bandviewsettings{'BAND_REWRITE'} eq "on") {	###allow rewriting of rules 'at will'
#		if (($bandviewsettings{'BAND_REWRITE'} eq "on") && ($bandviewsettings{'BAND_COLUMN'} ne "0")) {
			system ("/usr/local/bin/bandviewhelper >/dev/null");
#			system ("$sudo ${swroot}/modsys/helper.d/bandview");	###modsys
		}
		&writehash("${swroot}/preferences/bandview4", \%bandviewsettings);
	}
}


sub bandviewUPDATEusagepl {	###support for usage.pl by Matthew Yager (Unicorn)
	open(FILE,">$bandviewsettings{'BAND_USAGEPL'}") or die 'Unable to open config file.';
	flock FILE, 2;
	print FILE "$bandviewsettings{'BAND_ANNIVERSARY'}";
	close(FILE);
}


sub bandviewTABinfo {	###code adapted from graphs.cgi by The Smoothwall Team
	my @values = split(/&/, $ENV{'QUERY_STRING'});
	foreach my $t (@values)
	{
	        ($varname, $mydata) = split(/=/, $t);
	        if ($varname eq 't')
	        {
	                $bandviewtabnumber = $mydata;
	        }
	}
}


sub bandviewSORTING {
	if (($bandviewsettings{'BAND_REVERSE'} ne "on") && ($bandviewsettings{'BAND_COLUMN'} ne "0")) {
		if ($bandviewsettings{'BAND_COLUMN'} eq '5' | $bandviewsettings{'BAND_COLUMN'} eq '3') {
			system ("/bin/sort $bandviewsettings{'BAND_USERLIST'} -n -k $bandviewsettings{'BAND_COLUMN'}.1 -t , -o $bandviewsettings{'BAND_USERLIST'}");
		} else {
			system ("/bin/sort $bandviewsettings{'BAND_USERLIST'} -k $bandviewsettings{'BAND_COLUMN'}.1 -t , -o $bandviewsettings{'BAND_USERLIST'}");
		}
	} elsif (($bandviewsettings{'BAND_REVERSE'} eq "on") && ($bandviewsettings{'BAND_COLUMN'} ne "0")) {
		if ($bandviewsettings{'BAND_COLUMN'} eq '5' | $bandviewsettings{'BAND_COLUMN'} eq '3') {
			system ("/bin/sort $bandviewsettings{'BAND_USERLIST'} -n -k $bandviewsettings{'BAND_COLUMN'}.1 -t , -r -o $bandviewsettings{'BAND_USERLIST'}");
		} else {
			system ("/bin/sort $bandviewsettings{'BAND_USERLIST'} -k $bandviewsettings{'BAND_COLUMN'}.1 -t , -r -o $bandviewsettings{'BAND_USERLIST'}");
		}
	}
}


sub ip2number {
	my $ip = $_[0];
	if (!($ip =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/)) {
		return 0; 
	} else {
		return ($1*(256*256*256))+($2*(256*256))+($3*256)+$4; 
	}
}