#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
###2004-0327 - bandview.pl v.0.1.1 created by catastrophe for use with Bandview v.0.1.1
# - The "get data routine" was inspired by format.pl by martin.john
# - Color graph routine inspired by advstatus.cgi by The Smoothwall Team
# - Added 'by anniversary' support via usage.pl (2004-0107) by Matthew Yager (Unicorn) 
# - Calculate and generate bandwidth use/over-use with graph for current month 'by anniversary'
# - Added choice for no bandwidth cap or limit
###2004-0329 - bandview.pl v0.2.1 by catastrophe for use with Bandview v.0.2.1
# - Updated code credits. Sorry if I left anyone out by mistake.
###2004-0331 - bandview.pl v0.3 by catastrophe for use with Bandview v.0.3
# - Added green and orange to monthly monitor
# - Added support for users manually added to writeipac.pl as described in the IP Accounting mod by mpot on 2004-0107
###2004-0421 - bandview.pl v0.4 by catastrophe for use with Bandview v.0.4
# - Fixed some variable initialization problems
# - Fixed "failed thisperiod.stats creation" by removing LF from usage.dat
###2004-0729 - bandview.pl v0.5 by catastrophe for use with Bandview v.0.5
# - Added user monitor totals
# - Added 'in only' calculations for monthly monitor
# - Incorporated "DAYS USED mod" contribution by Andrew Brown (andrewb)
# - Fixed 'totals/used' to correctly display 'in only' when 'in only' checked (thanks del)
# - Added support for the BLUE Interface mod by Daniel Hokka Zakrisson (daniel_hozac)
# - Added daily in/out average (DAY AVERAGES) for current month by anniversary
###2004-1130 - bandview.pl v0.6 by catastrophe for use with Bandview v0.6
# - Day Average "Megabytes Left/Day Remaining" can now show negative if exceeded
# - Added individualized user cap
# - Calculate usage by both, in only, or out only
###2004-1215 - bandview.pl v0.6.1 by catastrophe for use with Bandview v0.6.1
# - Fixed "carry over bug" from previous user entry if 'userbandper is less than one' (thanks dunmarie)
# - Changed "hide" in user monitor to 'null only', will now show 'triple-zeroes'
# - "Username mouse-over" in 'monthly monitor' shows user "IP - Description"
# - Prepped to calculate incoming/outgoing exclusions to red incoming/outgoing
#
#
# - Disclaimer:
#    - Use at your own risk without any or implied warranty, etc.
###



############
###HEADER###
############

require '/var/smoothwall/header.pl';

###############
###VARIABLES###
###############

$bandmonthfile="/var/lib/ipac/ipacsum.thisperiod.stats";	###support for usage.pl generated month by anniversary
#$bandmonthfile="/tmp/ipacsum.thisperiod.stats.blue";	###debugging

open (FILE,"< $bandmonthfile") || die "Can't read ipacsum.thisperiod.stats";
     @bandmonthdata = <FILE>;
close(FILE);

$bandviewsettings{'BAND_ALLOTTED'} = '10000';
$bandviewsettings{'BAND_USERCAP'} = '0';
$bandviewsettings{'BAND_USERNAME'} = 'none';
#$bandviewsettings{'BAND_INONLY'} = 'off';
$bandviewsettings{'BAND_HIDETRIPLEZEROES'} = 'off';
$bandviewsettings{'BAND_ANNIVERSARY'} = '1';
$bandviewsettings{'BAND_USERLIST'} = "/var/smoothwall/preferences/bandview-userlist";
$bandviewsettings{'BAND_CALCULATEWHAT'} = 'both';
&readhash("${swroot}/preferences/bandview", \%bandviewsettings);

$bandmax=$bandviewsettings{'BAND_ALLOTTED'}; ###maximum allowed in megabytes

$bandhost="";
$banddata="";
$bandin=0;          ###Incoming RED
$bandout=0;         ###Outgoing RED
$bandtot=0;         ###Total RED
$bandfree=0;
$bandover=0;
$bandoverfontcolor="#fffff";
$bandoverbgcolor="#00000";
#$bandoverbgcolor=$graphbgcolour;
$orangebandmax=0;
$greenbandin=0;     ###Incoming GREEN
$greenbandout=0;    ###Outgoing GREEN
$greenbandtot=0;    ###Total GREEN
$orangebandmax=0;
$orangebandin=0;    ###Incoming ORANGE
$orangebandout=0;   ###Outgoing ORANGE
$orangebandtot=0;   ###Total ORANGE
$bluebandmax=0;
$bluebandin=0;    ###Incoming BLUE
$bluebandout=0;   ###Outgoing BLUE
$bluebandtot=0;   ###Total BLUE
$userbandmax=$bandviewsettings{'BAND_USERCAP'};
$bandusername=$bandviewsettings{'BAND_USERNAME'};
$userbandtotalin=0;		###Incoming USER
$userbandtotalout=0;		###Outgoing USER
$userbandtotalused=0;	###Total USER

$redexbandin=0;	###Excluded Incoming RED
$redexbandout=0;	###Excluded Outgoing RED
$redexbandtot=0;	###Excluded Total RED

my %userbandtot;    ###user total
my %userbandin;     ###user in
my %userbandout;    ###user out
my %userbandover;
my %userbandper;

my %bandviewUSERS;		###user name
my %bandviewUSERScap;	###user cap
my %bandviewUSERSipaddr;	###user ip
my %bandviewUSERSinfo;	###user description

$monthdays=0;		###Days in Anniversary Month
$monthused=0;		###Days already gone
$monthleft=0;		###Days to go
$monthper=0;		###Percentage of Days gone
@daysinmonth=(31,28,31,30,31,30,31,31,30,31,30,31);	###days in month

$bandavgin=0;		###day average in (in / days already gone)
$bandavgout=0;	###day average out (out / days already gone)
$bandavgcap=0;	###day average cap (isp cap / days in anniversary month)
$bandavgused=0;	###day average used (in+out / days already gone)
$bandavgfree=0;	###day average used (isp cap-in+out / days to go)

##########
###MAIN###
##########

&bandviewGETusers();
&bandGETDATAmonth();
&bandCALCULATIONSmonth();
&bandCALCULATEdaysused();
&bandPRINTmonth();

if (-e $bandviewsettings{'BAND_USERLIST'}) {
	&bandPRINTmonthuser();
}

&bandPRINTdaysused();
&bandCALCULATEdayaverage();
&bandPRINTdayaverage();

if ($bandviewsettings{BAND_USERNAME} eq "none") {	###reminder to edit###
	print "</table>\n";
}


##########
###DONE###
##########






#################
###SUBROUTINES###
#################

sub bandGETDATAmonth {
	for ($i=0; $i <= $#bandmonthdata; $i++) {
		$band = $bandmonthdata[$i];

		if ($band =~ /^Host/){
			chomp ($band);
			$bandhost = $band;
		} elsif ($band =~ /^Data/){
			chomp ($band);
			$banddata = $band;
		} elsif ($band =~ /Excluded Incoming/){   ###Excluded Incoming RED
			chomp ($band);
			@line=split (/:/, $band);
			$line[1]=~s/ //g;
			$line[1]=~s/M//g;
			$redexbandin=$redexbandin+$line[1];
		} elsif ($band =~ /Excluded Outgoing/){   ###Excluded Outgoing RED
			chomp ($band);
			@line=split (/:/, $band);
       	  	$line[1]=~s/ //g;
			$line[1]=~s/M//g;
			$redexbandout=$redexbandout+$line[1];
		} elsif ($band =~ /Incoming RED/){      ###Incoming RED
			chomp ($band);
			@line=split (/:/, $band);
			$line[1]=~s/ //g;    
			$line[1]=~s/M//g;
			$bandin=$bandin+$line[1];
		} elsif ($band =~ /Outgoing RED/){      ###Outgoing RED
			chomp ($band);
			@line=split (/:/, $band);
			$line[1]=~s/ //g;
			$line[1]=~s/M//g;
			$bandout=$bandout+$line[1];
		} elsif ($band =~ /Incoming GREEN/){     ###Incoming GREEN
			chomp ($band);
			@line=split (/:/, $band);
			$line[1]=~s/ //g;    
			$line[1]=~s/M//g;
			$greenbandin=$greenbandin+$line[1];
		} elsif ($band =~ /Outgoing GREEN/){    ###Outgoing GREEN
			chomp ($band);
			@line=split (/:/, $band);
			$line[1]=~s/ //g;
			$line[1]=~s/M//g;
			$greenbandout=$greenbandout+$line[1];
		} elsif ($band =~ /Incoming ORANGE/){    ###Incoming ORANGE
			chomp ($band);
			@line=split (/:/, $band);
			$line[1]=~s/ //g;    
			$line[1]=~s/M//g;
			$orangebandin=$orangebandin+$line[1];
		} elsif ($band =~ /Outgoing ORANGE/){   ###Outgoing ORANGE
			chomp ($band);
			@line=split (/:/, $band);
			$line[1]=~s/ //g;
			$line[1]=~s/M//g;
			$orangebandout=$orangebandout+$line[1];
		} elsif ($band =~ /Incoming BLUE/){    ###Incoming BLUE
			chomp ($band);
			@line=split (/:/, $band);
			$line[1]=~s/ //g;    
			$line[1]=~s/M//g;
			$bluebandin=$bluebandin+$line[1];
		} elsif ($band =~ /Outgoing BLUE/){   ###Outgoing BLUE
			chomp ($band);
			@line=split (/:/, $band);
			$line[1]=~s/ //g;
			$line[1]=~s/M//g;
			$bluebandout=$bluebandout+$line[1];
		} else {
			for ($x=0; $x <= $#bandviewUSERS; $x++) {
				if ($band =~ /$bandviewUSERS[$x] in/){         ###user in
					chomp ($band);
					@line=split (/:/, $band);
					$line[1]=~s/ //g;    
					$line[1]=~s/M//g; 
					$userbandin[$x]=$userbandin[$x]+$line[1];   
				} elsif ($band =~ /$bandviewUSERS[$x] out/){   ###user out
					chomp ($band);
					@line=split (/:/, $band);
					$line[1]=~s/ //g;
					$line[1]=~s/M//g; 
					$userbandout[$x]=$userbandout[$x]+$line[1];  
				}
			}
		}
	}
}


sub bandCALCULATIONSmonth {
	$bandin=$bandin-$redexbandin;   ###Excluded applied to Incoming Red
	$bandout=$bandout-$redexbandout;   ###Excluded applied to Outgoing Red

	$bandtot=$bandin+$bandout;

	if ($bandviewsettings{'BAND_CALCULATEWHAT'} eq 'inonly') {
		$bandfree=$bandmax-$bandin;
		$bandtot=$bandin
	} elsif ($bandviewsettings{'BAND_CALCULATEWHAT'} eq 'outonly') {
		$bandfree=$bandmax-$bandout;
		$bandtot=$bandout
	} else {
		$bandfree=$bandmax-$bandtot;
	}

	$greenbandtot=$greenbandin+$greenbandout;
	$orangebandtot=$orangebandin+$orangebandout;
	$bluebandtot=$bluebandin+$bluebandout;

	if ($bandmax eq 0) {
		$bandper = 0;
	} else {
		if ($bandviewsettings{'BAND_CALCULATEWHAT'} eq 'inonly') {
			$bandper = int((($bandin/$bandmax)*100));
		} elsif ($bandviewsettings{'BAND_CALCULATEWHAT'} eq 'outonly') {
			$bandper = int((($bandout/$bandmax)*100));
		} else {
			$bandper = int((($bandtot/$bandmax)*100));
		}
	}

	if ($bandper >= 100){   
		$bandover=$bandper-100;
		$bandper=100;
	}
}


sub bandCALCULATIONSusermonth {
	$userbandmax = $bandviewUSERScap[$i];

	$userbandtot[$i]=$userbandin[$i]+$userbandout[$i];

	if ($bandviewsettings{'BAND_CALCULATEWHAT'} eq 'inonly') {
		$userbandfree[$i]=$userbandmax-$userbandin[$i];
		$userbandtot[$i]=$userbandin[$i]
	} elsif ($bandviewsettings{'BAND_CALCULATEWHAT'} eq 'outonly') {
		$userbandfree[$i]=$userbandmax-$userbandout[$i];
		$userbandtot[$i]=$userbandout[$i]
	} else {
		$userbandfree[$i]=$userbandmax-$userbandtot[$i];
	}

	$userbandtotalin=$userbandtotalin+$userbandin[$i];
	$userbandtotalout=$userbandtotalout+$userbandout[$i];
	$userbandtotalused=$userbandtotalused+$userbandtot[$i];

	if ($userbandmax eq 0) {
		$userbandper[$i] = 0;
	} else {
		if ($bandviewsettings{'BAND_CALCULATEWHAT'} eq 'inonly') {
			$userbandper[$i] = int((($userbandin[$i]/$userbandmax)*100));
		} elsif ($bandviewsettings{'BAND_CALCULATEWHAT'} eq 'outonly') {
			$userbandper[$i] = int((($userbandout[$i]/$userbandmax)*100));
		} else {
			$userbandper[$i] = int((($userbandtot[$i]/$userbandmax)*100));
		}
	}

	if ($userbandper[$i] >= 100){   
		$userbandover[$i]=$userbandper[$i]-100; 
		$userbandper[$i]=100;
	}
}


sub bandCALCULATEdaysused { ###DAYS USED mod contributed by Andrew Brown (andrewb)
	# Get date data for today
	$CurDate = (localtime(time()))[3];
	$CurMonth = (localtime(time()))[4] + 1;
	$CurYear = (localtime(time()))[5] + 1900;

	# Get Anniversary Day from
	$AnniversaryDay = $bandviewsettings{'BAND_ANNIVERSARY'};

	# Check if this is a leap year
	if ($CurYear eq ((int($CurYear/4))*4)) {
		$daysinmonth[1]=29;	# this is a leap year - February has 29 days
	}

	if ($CurDate < $AnniversaryDay) {
		$CurMonth = $CurMonth - 1;	# The EOM boundary has been crossed

		if ($CurMonth eq 0) {
			$CurMonth = 12;	# wraps to December last year
		}
		$monthdays = $daysinmonth[$CurMonth - 1];
		$monthused = $monthdays - $AnniversaryDay + $CurDate;
	} else {
		$monthdays = $daysinmonth[$CurMonth - 1];
		$monthused = $CurDate - $AnniversaryDay;
	}
	$monthleft = $monthdays - $monthused;
	$monthper = int((($monthused/$monthdays)*100));
}


sub bandCALCULATEdayaverage {
#	$monthused = 0;	###debugging
#	$monthleft = 0;	###debugging

	if ($monthused eq 0) {
		$monthused = 1;
	}
	$bandavgin = int($bandin/$monthused);
	$bandavgout = int($bandout/$monthused);
	$bandavgused = int($bandtot/$monthused);

	if ($bandmax eq 0) {
		###then do nothing
	} else {
		$bandavgcap = int($bandmax/$monthdays);
		
		if ($monthleft eq 0) {
			$monthleft = 1;	###prevent division by zero
		}
		$bandavgfree = int($bandfree/$monthleft);

#		if ($bandavgfree < 0) {
#			$bandavgfree=0;	###commented out to allow 'negative free'
#		}
	}
}


sub bandPRINTmonth {
	print "\n";
	print "Bandwidth consumption for current month 'by anniversary' in megabytes.\n";
#	print "$bandhost\n";
	print "$banddata (updated every 11 minutes)";

	$bandgraphper=$bandper; &bandGRAPHcolorsnow();

	print "<table border='0' cellspacing='0' cellpadding='2'>";

	print qq|
	<tr><td><tt>&nbsp;</tt></td></tr>
	<tr>
	<td width="80" align="left"><tt>Interface</tt></td>
	<td width="60" align="right"><tt>Cap</tt></td>
	<td width="60" align="right"><tt>In</tt></td>
	<td width="60" align="right"><tt>Out</tt></td>
	<td width="60" align="right"><tt>Used</tt></td>
	<td width="60" align="right"><tt>Left</tt></td>
	<td width="5"><tt>&nbsp;</tt></td>
	<td width="150" align="center"><tt>Used %</tt></td>
	<td width="150" align="center"><tt>Over %</tt></td>
	</tr>
	|;

	###print RED###
	if ($bandmax eq 0) {
		print qq|
		<tr>
		<td align='left'><tt><b><font color=#ff6060>RED</font></b></tt></td>
		<td align='right'><tt><b>-</b></tt><tt><font color=#666666> </font></tt></td>
		<td align='right'><tt><b>$bandin</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>$bandout</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>$bandtot</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>-</b></tt><tt><font color=#666666> </font></tt></td>
		<td><tt>&nbsp;</tt></td>
		|;
	} else {
		print qq|
		<tr>
		<td align='left'><tt><b><font color=#ff6060>RED</font></b></tt></td>
		<td align='right'><tt><b>$bandmax</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>$bandin</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>$bandout</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>$bandtot</b></tt><tt><font color=#666666>M</font></tt></td>
 		<td align='right'><tt><b>$bandfree</b></tt><tt><font color=#666666>M</font></tt></td>
		<td><tt>&nbsp;</tt></td>
 		|;
	}
	print "<TD><table width='100%' border='0' cellspacing='0' cellpadding='0'>";

	if (int($bandper) < 1) {
		print "<td bgcolor='$graphbgcolour' width='1%' align='center'><tt>$bandper%</tt></td>";
	} else {
		print "<td bgcolor='$graphbgcolour' width='$bandper%' align='center'><tt>$bandper%</tt></td>";
	}
 
	if (int($bandper) < 100) {
		print "<td bgcolor='$graphblankcolour'>&nbsp;</td>";
	} else{
		print "<td bgcolor='$graphbgcolour'>&nbsp;</td>";
	}
	print "</table></TD>";
	print "<TD><table width='100%' border='0' cellspacing='0' cellpadding='0'>";
 
	if (int($bandover) > 0) {
		print "<td bgcolor='$bandoverbgcolor' width='$bandover%' align='center'><tt><font color='$bandoverfontcolor'>+$bandover%</font></tt></td>";
	}
 
	if (int($bandover) < 100) {
		print "<td bgcolor='$graphblankcolour'>&nbsp;</td>";
	} else {
		print "<td bgcolor='$bandoverbgcolor'>&nbsp;</td>";
	}
	print "</table></TD>";
	print "</TR>";

	###print GREEN###
	print qq|
	<tr>
	<td align='left'><tt><b><font color=#60aa60>GREEN</font></b></tt></td>
	<td align='right'><tt><b>-</b></tt><tt><font color=#666666> </font></tt></td>
	<td align='right'><tt><b>$greenbandin</b></tt><tt><font color=#666666>M</font></tt></td>
	<td align='right'><tt><b>$greenbandout</b></tt><tt><font color=#666666>M</font></tt></td>
	<td align='right'><tt><b>$greenbandtot</b></tt><tt><font color=#666666>M</font></tt></td>
	<td align='right'><tt><b>-</b></tt><tt><font color=#666666> </font></tt></td>
	<td><tt>&nbsp;</tt></td>
	<td><tt>&nbsp;</tt></td>
	<td><tt>&nbsp;</tt></td>
	</tr>
	|;

	###print ORANGE###
	if ($orangebandtot eq "0") {
#	if ($orangebandtot eq "1") {	###debugging
 		###then do nothing
	} else {
		print qq|
 		<tr>
		<td align='left'><tt><b><font color=#ff9900>ORANGE</font></b></tt></td>
		<td align='right'><tt><b>-</b></tt><tt><font color=#666666> </font></tt></td>
		<td align='right'><tt><b>$orangebandin</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>$orangebandout</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>$orangebandtot</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>-</b></tt><tt><font color=#666666> </font></tt></td>
		<td><tt>&nbsp;</tt></td>
		<td><tt>&nbsp;</tt></td>
		<td><tt>&nbsp;</tt></td>
		</tr>
		|;
	}

	###print BLUE###
	if ($bluebandtot eq "0") {
#	if ($bluebandtot eq "1") {	###debugging
 		###then do nothing
	} else {
		print qq|
 		<tr>
		<td align='left'><tt><b><font color=#0000FF>BLUE</font></b></tt></td>
		<td align='right'><tt><b>-</b></tt><tt><font color=#666666> </font></tt></td>
		<td align='right'><tt><b>$bluebandin</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>$bluebandout</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>$bluebandtot</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>-</b></tt><tt><font color=#666666> </font></tt></td>
		<td><tt>&nbsp;</tt></td>
		<td><tt>&nbsp;</tt></td>
		<td><tt>&nbsp;</tt></td>
		</tr>
		|;
	}
#	print "</table>";
}


sub bandPRINTmonthuser {
	###print USER###
#	print "<table border='0' cellspacing='0' cellpadding='2'>";

#	if ($bandviewsettings{BAND_USERNAME} ne "none") {
#		print "<tr><TD><tt> </tt></TD></tr>";
#		print "<tr><TD><tt> </tt></TD></tr>";
#	}

	print qq|
	<tr><td><tt>&nbsp;</tt></td></tr>
	<tr>
	<td width="80" align="left"><tt>Username</tt></td>
	<td width="60" align="right"><tt>Cap</tt></td>
	<td width="60" align="right"><tt>In</tt></td>
	<td width="60" align="right"><tt>Out</tt></td>
	<td width="60" align="right"><tt>Used</tt></td>
	<td width="60" align="right"><tt>Left</tt></td>
	<td width="5" ><tt>&nbsp;</tt></td>
	<td width="150" align="center"><tt>Used %</tt></td>
	<td width="150" align="center"><tt>Over %</tt></td>
	</tr>
	|;

	for ($i=0; $i <= $#bandviewUSERS; $i++) {
		&bandCALCULATIONSusermonth();

#		if (($userbandtot[$i] eq "0") || ($userbandtot[$i] eq "")) {	###hide if null or zero
#		if (($userbandtot[$i] eq "") || ($userbandtot[$i] eq "0") && ($userbandin[$i] eq "0") && ($userbandout[$i] eq "0")) {	###hide if null or triple-zero
		if (($userbandtot[$i] eq "") || ($userbandtot[$i] eq "0") && ($userbandin[$i] eq "") && ($userbandout[$i] eq "")) {	###hide if null
			### then do nothing
		} elsif (($bandviewsettings{'BAND_HIDETRIPLEZEROES'} eq "on") && ($userbandin[$i] eq "0") && ($userbandout[$i] eq "0")) {	###hide triple-zeroes
			### then do nothing
		} else {

			if ($userbandmax eq 0) {
 				print qq|
 				<tr>
				<td style='cursor: pointer' title="$bandviewUSERSipaddr[$i] - $bandviewUSERSinfo[$i]" align='left'><tt><b><font color=#00000>$bandviewUSERS[$i]</font></b></tt></td>
				<td align='right'><tt><b>-</b></tt><tt><font color=#666666> </font></tt></td>
				<td align='right'><tt><b>$userbandin[$i]</b></tt><tt><font color=#666666>M</font></tt></td>
				<td align='right'><tt><b>$userbandout[$i]</b></tt><tt><font color=#666666>M</font></tt></td>
				<td align='right'><tt><b>$userbandtot[$i]</b></tt><tt><font color=#666666>M</font></tt></td>
				<td align='right'><tt><b>-</b></tt><tt><font color=#666666> </font></tt></td>
				<td><tt>&nbsp;</tt></td>
				|;
			} else {
				print qq|
				<tr>
				<td style='cursor: pointer' title="$bandviewUSERSipaddr[$i] - $bandviewUSERSinfo[$i]" align='left'><tt><b><font color=#00000>$bandviewUSERS[$i]</font></b></tt></td>
				<td align='right'><tt><b>$userbandmax</b></tt><tt><font color=#666666>M</font></tt></td>
				<td align='right'><tt><b>$userbandin[$i]</b></tt><tt><font color=#666666>M</font></tt></td>
				<td align='right'><tt><b>$userbandout[$i]</b></tt><tt><font color=#666666>M</font></tt></td>
 				<td align='right'><tt><b>$userbandtot[$i]</b></tt><tt><font color=#666666>M</font></tt></td>
				<td align='right'><tt><b>$userbandfree[$i]</b></tt><tt><font color=#666666>M</font></tt></td>
				<td><tt>&nbsp;</tt></td>
				|;
			}

			$bandgraphper=$userbandper[$i]; &bandGRAPHcolorsnow();

			print "<TD><table width='100%' border='0' cellspacing='0' cellpadding='0'>\n";

			if (int($userbandper[$i]) < 1) {
#				print "<td bgcolor='$graphbgcolour' width='1%' align='center'><tt>$userbandper[%i]%</tt></td>\n";
				print "<td bgcolor='$graphbgcolour' width='1%' align='center'><tt>0%</tt></td>\n";
			} else {
				print "<td bgcolor='$graphbgcolour' width='$userbandper[$i]%' align='center'><tt>$userbandper[$i]%</tt></td>\n";
			}
 
			if (int($userbandper[$i]) < 100) {
				print "<td bgcolor='$graphblankcolour'>&nbsp;</td>\n";
			} else {
				print "<td bgcolor='$graphbgcolour'>&nbsp;</td>\n";
			}
    			print "</table></TD>\n";
			print "<TD><table width='100%' border='0' cellspacing='0' cellpadding='0'>\n";
 
			if (int($userbandover[$i]) > 0) {
				print "<td bgcolor='$bandoverbgcolor' width='$userbandover[$i]%' align='center'><tt><font color='$bandoverfontcolor'>+$userbandover[$i]%</font></tt></td>\n";
			}
 
			if (int($userbandover[$i]) < 100) {
				print "<td bgcolor='$graphblankcolour'>&nbsp;</td>\n";
			} else {
				print "<td bgcolor='$bandoverbgcolor'>&nbsp;</td>\n";
			}
			print "</table></TD>\n";
			print "</TR>\n";
		}
	}

	print qq|
	<tr>
	<td align='left'><tt><b><font color=#666666>User totals</font></b></tt></td>
	<td align='right'><tt><b>-</b></tt><tt><font color=#666666> </font></tt></td>
	<td align='right'><tt><b>$userbandtotalin</b></tt><tt><font color=#666666>M</font></tt></td>
	<td align='right'><tt><b>$userbandtotalout</b></tt><tt><font color=#666666>M</font></tt></td>
	<td align='right'><tt><b>$userbandtotalused</b></tt><tt><font color=#666666>M</font></tt></td>
	<td align='right'><tt><b>-</b></tt><tt><font color=#666666> </font></tt></td>
	<td><tt>&nbsp;</tt></td>
	<td><tt>&nbsp;</tt></td>
	<td><tt>&nbsp;</tt></td>
	</tr>
	|;

#	print "</table>";

}


sub bandPRINTdaysused { ###DAYS USED mod contributed by Andrew Brown (andrewb)
	$bandgraphper=$monthper; &bandGRAPHcolorsnow();

#	print "<table border='0' cellspacing='0' cellpadding='2'>";

	print qq|
	<tr><td><tt>&nbsp;</tt></td></tr>
	<tr>
	<td width="80" align="left"><tt>Miscellaneous</tt></td>
	<td width="60" align="right"><tt>Cap</tt></td>
	<td width="60" align="right"><tt>In</tt></td>
	<td width="60" align="right"><tt>Out</tt></td>
	<td width="60" align="right"><tt>Used</tt></td>
	<td width="60" align="right"><tt>Left</tt></td>
	<td width="5"><tt>&nbsp;</tt></td>
	<td width="150" align="center"><tt>Used %</tt></td>
	<td width="150" align="center"><tt>&nbsp;</tt></td>
	</tr>
	|;

	###print DAYS USED###
	print qq|
	<tr>
	<td align='left'><tt><b><font color=#00000>DAYS USED</font></b></tt></td>
	<td align='right'><tt><b>$monthdays</b></tt><tt><font color=#666666>d</font></tt></td>
	<td align='right'><tt><b>-</b></tt><tt><font color=#666666> </font></tt></td>
	<td align='right'><tt><b>-</b></tt><tt><font color=#666666> </font></tt></td>	
	<td align='right'><tt><b>$monthused</b></tt><tt><font color=#666666>d</font></tt></td>
	<td align='right'><tt><b>$monthleft</b></tt><tt><font color=#666666>d</font></tt></td>
	<td><tt>&nbsp;</tt></td>
	|;

	print "<TD><table width='100%' border='0' cellspacing='0' cellpadding='0'>\n";

	if (int($monthper) < 1) {
		print "<td bgcolor='$graphbgcolour' width='1%' align='center'><tt>$monthper%</tt></td>\n";
	} else {
		print "<td bgcolor='$graphbgcolour' width='$monthper%' align='center'><tt>$monthper%</tt></td>\n";
	}
 
	if (int($monthper) < 100) {
		print "<td bgcolor='$graphblankcolour'>&nbsp;</td>\n";
	} else {
		print "<td bgcolor='$graphbgcolour'>&nbsp;</td>\n";
	}
	
	print "</table></TD>\n";
	print "<td><tt>&nbsp;</tt></td>\n";
	print "</TR>\n";
}


sub bandPRINTdayaverage {
	###print Daily Averages###
	if ($bandmax eq 0) {
		print qq|
		<tr>
		<td align='left'><tt><b><font color=#00000>DAY AVERAGES</font></b></tt></td>
		<td align='right'><tt><b>-</b></tt><tt><font color=#666666> </font></tt></td>
		<td align='right'><tt><b>$bandavgin</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>$bandavgout</b></tt><tt><font color=#666666>M</font></tt></td>	
		<td align='right'><tt><b>$bandavgused</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>-</b></tt><tt><font color=#666666> </font></tt></td>
		<td><tt>&nbsp;</tt></td>
		<td><tt>&nbsp;</tt></td>
		<td><tt>&nbsp;</tt></td>
		</tr>
		|;
	} else {
		print qq|
		<tr>
		<td align='left'><tt><b><font color=#00000>DAY AVERAGES</font></b></tt></td>
		<td align='right'><tt><b>$bandavgcap</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>$bandavgin</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>$bandavgout</b></tt><tt><font color=#666666>M</font></tt></td>	
		<td align='right'><tt><b>$bandavgused</b></tt><tt><font color=#666666>M</font></tt></td>
		<td align='right'><tt><b>$bandavgfree</b></tt><tt><font color=#666666>M</font></tt></td>
		<td><tt>&nbsp;</tt></td>
		<td><tt>&nbsp;</tt></td>
		<td><tt>&nbsp;</tt></td>
		</tr>
		|;
	}

}


sub bandGRAPHcolorsnow { ###color graph routine inspired by advstatus.cgi by The Smoothwall Team
	if (int($bandgraphper) > $graphalertcritical) {
		$graphbgcolour = $graphcriticalcolour;
	} elsif (int($bandgraphper) > $graphalertwarning) {
		$graphbgcolour = $graphwarningcolour;
	} elsif (int($bandgraphper) > 0) {
		$graphbgcolour = $graphnominalcolour;
	} else {
		$graphbgcolour = $graphblankcolour;
	}
}


sub bandviewGETusers {
	if (-e $bandviewsettings{'BAND_USERLIST'}) {
		@bandviewUSERS = `cat $bandviewsettings{'BAND_USERLIST'}`;

		for ($i=0; $i <= $#bandviewUSERS; $i++){
			chomp ($bandviewUSERS[$i]);
			my @bandviewmembership = split(/\,/,$bandviewUSERS[$i]);
			$bandviewUSERS[$i] = $bandviewmembership[0];
			$bandviewUSERScap[$i] = $bandviewmembership[2];
			$bandviewUSERSipaddr[$i] = $bandviewmembership[1];
			$bandviewUSERSinfo[$i] = $bandviewmembership[3];
		}
	}
}
